import { type IType, type Opt, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class ScsStudentgroup {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  Name?: string;
  TotalStudent!: number;
  Enabled!: unknown;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
  TeacherId!: IType<number, bigint> & Opt;
  Type: number & Opt = 0;
}

export const ScsStudentgroupSchema = defineEntity({
  class: ScsStudentgroup,
  comment: '学生分组',
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    Name: p.string().name('Name').nullable().comment('模板名称'),
    TotalStudent: p.integer().name('TotalStudent').comment('学生人数'),
    Enabled: p.array().name('Enabled').comment('启用'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
    TeacherId: p.bigint().name('TeacherId').columnType('bigint').comment('管理教师Id').defaultRaw(`0`).index('idx_SCS_StudentGroup_01'),
    Type: p.integer().name('Type').comment('0:普通分组 1:辅导班分组'),
  },
});
